package org.dromara.elevator.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.ERescueInfo;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.ESignInInfoBo;
import org.dromara.elevator.domain.vo.ESignInInfoVo;
import org.dromara.elevator.domain.ESignInInfo;
import org.dromara.elevator.mapper.ESignInInfoMapper;
import org.dromara.elevator.service.IESignInInfoService;

import java.util.List;
import java.util.Map;
import java.util.Collection;
import java.util.Objects;

/**
 * 签到管理;Service业务层处理
 *
 * @author zy
 * @date 2024-07-29
 */
@RequiredArgsConstructor
@Service
public class ESignInInfoServiceImpl implements IESignInInfoService {

    private final ESignInInfoMapper baseMapper;

    /**
     * 查询签到管理;
     *
     * @param id 主键
     * @return 签到管理;
     */
    @Override
    public ESignInInfoVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询签到管理;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 签到管理;分页列表
     */
    @Override
    public TableDataInfo<ESignInInfoVo> queryPageList(ESignInInfoBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ESignInInfo> lqw = buildQueryWrapper(bo);
        Page<ESignInInfoVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的签到管理;列表
     *
     * @param bo 查询条件
     * @return 签到管理;列表
     */
    @Override
    public List<ESignInInfoVo> queryList(ESignInInfoBo bo) {
        LambdaQueryWrapper<ESignInInfo> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ESignInInfo> buildQueryWrapper(ESignInInfoBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ESignInInfo> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getUserName()), ESignInInfo::getUserName, bo.getUserName());
        lqw.eq(bo.getLng() != null, ESignInInfo::getLng, bo.getLng());
        lqw.eq(bo.getLat() != null, ESignInInfo::getLat, bo.getLat());
        lqw.eq(StringUtils.isNotBlank(bo.getAddress()), ESignInInfo::getAddress, bo.getAddress());
        lqw.ge(Objects.nonNull(bo.getStartTime()), ESignInInfo::getSignTime, bo.getStartTime());
        lqw.le(Objects.nonNull(bo.getEndTime()), ESignInInfo::getSignTime, bo.getEndTime());
        lqw.orderByDesc(ESignInInfo::getCreateTime);
        return lqw;
    }

    /**
     * 新增签到管理;
     *
     * @param bo 签到管理;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ESignInInfoBo bo) {
        ESignInInfo add = MapstructUtils.convert(bo, ESignInInfo.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改签到管理;
     *
     * @param bo 签到管理;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ESignInInfoBo bo) {
        ESignInInfo update = MapstructUtils.convert(bo, ESignInInfo.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ESignInInfo entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除签到管理;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
